<?php
// Auto creating MethodTable
// include(AMFPHP_BASE . "util/MethodTable.php");

require_once("thumbnail.inc.php");

class Gallery
{

    var $galleryDataFilePath = '../../../../xxxxx_gallery.php';
    var $galleryDefaultsFilePath = '../../../../xxxxx_gallery_defaults.html';

    function Gallery()
	{
	    // $this->methodTable = MethodTable::create(__FILE__);

        // Define the methodTable for this class in the constructor
        $this->methodTable = array(
            "getGalleryOptions" => array(
                "description" => "Return gallery preferences",
                "access" => "remote"
            ),
            "getPreferences" => array(
                "description" => "Return gallery preferences",
                "access" => "remote"
            ),
            "getData" => array(
                "description" => "Return all the images from the gallery",
                "access" => "remote"
            ),
            "putData" => array(
                "description" => "Put categoories and images to the gallery file",
                "access" => "remote"
            )
        );

    }

    /**
        @desc Return gallery options
        @access remote
        @return array
    */
    function getGalleryOptions()
    {
        $tempArray = array();
        $dataArray = array();

        $fileContents = file_get_contents($this->galleryDefaultsFilePath);
        $fileContents = str_replace("\n", "", $fileContents);
        $fileContents = str_replace("\r", "", $fileContents);

        $tempArray = explode("&", $fileContents);

        for ($i=0; $i < count($tempArray); $i++) {
            if(!is_null($tempArray[$i]) && strlen($tempArray[$i]) > 0 && substr_count($tempArray[$i], "=") == 1) {
                $values = explode("=", $tempArray[$i]);
                $dataArray[$values[0]] = $values[1];
            }
        }

        // Options
        $options = array();

        $options['maxGalleriesAllowed'] = $dataArray['maxGalleriesAllowed'];
        $options['minImageWidth'] = $dataArray['minImageWidth'];
        $options['minImageHeight'] = $dataArray['minImageHeight'];
        $options['maxImageWidth'] = $dataArray['maxImageWidth'];
        $options['maxImageHeight'] = $dataArray['maxImageHeight'];
        $options['minPreviewWidth'] = $dataArray['minPreviewWidth'];
        $options['minPreviewHeight'] = $dataArray['minPreviewHeight'];
        $options['maxPreviewWidth'] = $dataArray['maxPreviewWidth'];
        $options['maxPreviewHeight'] = $dataArray['maxPreviewHeight'];
        $options['maxCommentChars'] = $dataArray['maxCommentChars'];

        $options['preview_position'] = $dataArray['preview_position'];
        $options['preview_offset'] = $dataArray['preview_offset'];
        $options['image_width'] = $dataArray['image_width'];
        $options['image_height'] = $dataArray['image_height'];
        $options['h_space'] = $dataArray['h_space'];
        $options['v_space'] = $dataArray['v_space'];
        $options['preview_width'] = $dataArray['preview_width'];
        $options['preview_height'] = $dataArray['preview_height'];
        $options['open_in_browser'] = $dataArray['open_in_browser'];
        $options['comment_position'] = $dataArray['comment_position'];

        return $options;
    }

    /**
        @desc Return gallery preferences
        @access remote
        @return array
    */
    function getPreferences()
    {
        $tempArray = array();
        $dataArray = array();

        $fileContents = file_get_contents($this->galleryDataFilePath);
        $fileContents = str_replace("\n", "", $fileContents);
        $fileContents = str_replace("\r", "", $fileContents);

        $tempArray = explode("&", $fileContents);

        for ($i=0; $i < count($tempArray); $i++) {
            if(!is_null($tempArray[$i]) && strlen($tempArray[$i]) > 0 && substr_count($tempArray[$i], "=") == 1) {
                $values = explode("=", $tempArray[$i]);
                $dataArray[$values[0]] = $values[1];
            }
        }

        // Prefrences
        $preferences = array();

        $preferences['preview_position'] = $dataArray['preview_position'];
        $preferences['preview_offset'] = $dataArray['preview_offset'];
        $preferences['image_width'] = $dataArray['image_width'];
        $preferences['image_height'] = $dataArray['image_height'];
        $preferences['h_space'] = $dataArray['h_space'];
        $preferences['v_space'] = $dataArray['v_space'];
        $preferences['preview_width'] = $dataArray['preview_width'];
        $preferences['preview_height'] = $dataArray['preview_height'];
        $preferences['open_in_browser'] = $dataArray['open_in_browser'];
        $preferences['comment_position'] = $dataArray['comment_position'];

        return $preferences;
    }

    /**
        @desc Return all the images from the gallery
        @access remote
        @return array
    */
    function getData()
    {

        $tempArray = array();
        $dataArray = array();

        $fileContents = file_get_contents($this->galleryDataFilePath);
        $fileContents = str_replace("\n", "", $fileContents);
        $fileContents = str_replace("\r", "", $fileContents);

        $tempArray = explode("&", $fileContents);

        for ($i=0; $i < count($tempArray); $i++) {
            if(!is_null($tempArray[$i]) && strlen($tempArray[$i]) > 0 && substr_count($tempArray[$i], "=") == 1) {
                $values = explode("=", $tempArray[$i]);
                $dataArray[$values[0]] = $values[1];
            }
        }

        // Categories
        $gallery_images = array();

        $i = 0;
        while(isset($dataArray['cat_'.$i])) {
            $gallery_images[$i]['id'] = $i;
            $gallery_images[$i]['category_name'] = $dataArray['cat_'.$i];
            $j = 0;
            while(isset($dataArray['cat_'.$i.'_pic_'.$j])) {
                $gallery_images[$i]['images'][$j]['id'] = $j;
                $gallery_images[$i]['images'][$j]['pic'] = $dataArray['cat_'.$i.'_pic_'.$j];
                $gallery_images[$i]['images'][$j]['comment'] = $dataArray['cat_'.$i.'_comment_'.$j];
                $j++;
                if($j>9999) break;
            }
            $i++;
            if($i>9999) break;
        }

        return $gallery_images;
    }

    /**
        @desc Put categoories and images to the gallery file
        @access remote
        @return boolean
    */
    function putData($dataObject, $preferences, $options, $imagesToRemove = null, $moveTo = false)
    {
        $galleryPath = '../../../../';

        $dataString = "// GALLERY \n\n";

        for($i = 0; $i < count($dataObject); $i++) {
            // Check if category was deleted
            if(isset($dataObject[$i]['deleteCategory']) && $dataObject[$i]['deleteCategory'] == 'delete') {
                @chmod($galleryPath.$dataObject[$i]['name'], 0777);
                if(!$this->deleteDirectory($galleryPath.$dataObject[$i]['name'])) {
                    return false;
                }
            } else {
                // Create new gallery folder
                if(isset($dataObject[$i]['newCategory']) && $dataObject[$i]['newCategory'] == 'create') {
                    if(!mkdir($galleryPath.$dataObject[$i]['name'])) {
                        return false;
                    } else {
                        chmod($galleryPath.$dataObject[$i]['name'], 0777);
                        mkdir($galleryPath.$dataObject[$i]['name'].'/big');
                        mkdir($galleryPath.$dataObject[$i]['name'].'/small');
                    }
                }
                $dataString .= "&cat_".$dataObject[$i]['id']."=".$dataObject[$i]['name']."& \n\n";
                // Rename folder if category name was changed
                if(isset($dataObject[$i]['old_name']) && $dataObject[$i]['name'] != $dataObject[$i]['old_name']) {
                    if(!rename($galleryPath.$dataObject[$i]['old_name'], $galleryPath.$dataObject[$i]['name'])) {
                        return false;
                    }
                }
                // Images loop
                for($j = 0; $j < count($dataObject[$i]['images']); $j++) {
                    if(isset($dataObject[$i]['images'][$j]['renamePic'])) {
                        // Thumbnail
                        if($dataObject[$i]['images'][$j]['renamePic'] == 'createThumbnail') {
                            $thumb = new Thumbnail($galleryPath.$dataObject[$i]['name']."/big/".$dataObject[$i]['images'][$j]['pic']);
                            $thumb->resize($preferences['image_width'], $preferences['image_height']);
                            $thumb->save($galleryPath.$dataObject[$i]['name']."/small/".$dataObject[$i]['images'][$j]['pic']);
                            $thumb->destruct();
                        } else {
                            chmod($galleryPath.$dataObject[$i]['name']."/small/".$dataObject[$i]['images'][$j]['renamePic'], 0777);
                            rename($galleryPath.$dataObject[$i]['name']."/small/".$dataObject[$i]['images'][$j]['renamePic'], $galleryPath.$dataObject[$i]['name']."/small/".$dataObject[$i]['images'][$j]['pic']);
                            // CHeck thumbnail size - resample
                            $thumb = new Thumbnail($galleryPath.$dataObject[$i]['name']."/small/".$dataObject[$i]['images'][$j]['pic']);
                            if($thumb->getCurrentWidth() > $preferences['image_width'] || $thumb->getCurrentHeight() > $preferences['image_height']) {
                                $thumb->resize($preferences['image_width'], $preferences['image_height']);
                                $thumb->save($galleryPath.$dataObject[$i]['name']."/small/".$dataObject[$i]['images'][$j]['pic']);
                            }
                            $thumb->destruct();
                        }
                        // Check size of the new uploaded full image
                        $thumb = new Thumbnail($galleryPath.$dataObject[$i]['name']."/big/".$dataObject[$i]['images'][$j]['pic']);
                        if($thumb->getCurrentWidth() > $options['maxPreviewWidth'] || $thumb->getCurrentHeight() > $options['maxPreviewHeight']) {
                            $thumb->resize($options['maxPreviewWidth'], $options['maxPreviewHeight']);
                            $thumb->save($galleryPath.$dataObject[$i]['name']."/big/".$dataObject[$i]['images'][$j]['pic']);
                        }
                        $thumb->destruct();
                    }

                    $dataString .= "&cat_".$dataObject[$i]['id']."_pic_".$j."=".$dataObject[$i]['images'][$j]['pic']."& \n";

                    if(strlen($dataObject[$i]['images'][$j]['comment']) > 0) {
                        $dataString .= "&cat_".$dataObject[$i]['id']."_comment_".$j."=".$dataObject[$i]['images'][$j]['comment']."& \n";
                    }
                }
                $dataString .= "\n\n";

            }
        }

        $dataString .= "// PREFERENCES \n\n";

        foreach ($preferences as $key => $value) {
            if($key == 'length') continue;
            $dataString .= "&".$key."=".$value."& \n";
        }
        $dataString .= "\n\n";

        // Remove images
        if($imagesToRemove && count($imagesToRemove) > 0) {
            if($moveTo) {
                for($i = 0; $i < count($imagesToRemove); $i++) {
                    copy($galleryPath.$imagesToRemove[$i]['category']."/big/".$imagesToRemove[$i]['pic'], $galleryPath.$imagesToRemove[$i]['target']."/big/".$imagesToRemove[$i]['pic']);
                    copy($galleryPath.$imagesToRemove[$i]['category']."/small/".$imagesToRemove[$i]['pic'], $galleryPath.$imagesToRemove[$i]['target']."/small/".$imagesToRemove[$i]['pic']);
                    @unlink($galleryPath.$imagesToRemove[$i]['category']."/big/".$imagesToRemove[$i]['pic']);
                    @unlink($galleryPath.$imagesToRemove[$i]['category']."/small/".$imagesToRemove[$i]['pic']);
                }
            } else {
                for($i = 0; $i < count($imagesToRemove); $i++) {
                    @unlink($galleryPath.$imagesToRemove[$i]['category']."/big/".$imagesToRemove[$i]['pic']);
                    @unlink($galleryPath.$imagesToRemove[$i]['category']."/small/".$imagesToRemove[$i]['pic']);
                }
            }
        }

        // Put contents
        $file = @fopen($this->galleryDataFilePath, "w");
        if(!$file) {
            return false;
        } else {
            fwrite($file, $dataString);
            fclose($file);
            return true;
        }
    }

    function deleteDirectory($dirname, $only_empty=false) {
       if (!is_dir($dirname))
           return false;
       $dscan = array(realpath($dirname));
       $darr = array();
       while (!empty($dscan)) {
           $dcur = array_pop($dscan);
           $darr[] = $dcur;
           if ($d=opendir($dcur)) {
               while ($f=readdir($d)) {
                   if ($f=='.' || $f=='..')
                       continue;
                   $f=$dcur.'/'.$f;
                   if (is_dir($f))
                       $dscan[] = $f;
                   else
                       unlink($f);
               }
               closedir($d);
           }
       }
       $i_until = ($only_empty)? 1 : 0;
       for ($i=count($darr)-1; $i>=$i_until; $i--) {
           rmdir($darr[$i]);
       }
       return (($only_empty)? (count(scandir)<=2) : (!is_dir($dirname)));
    }

}

?>